# coding: utf-8

"""
    OptHub REST API

    OptHub Public REST API.

    The version of the OpenAPI document: 0.3.0
    Contact: dev@opthub.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from opthub_api_client.models.runner_status import RunnerStatus
from opthub_api_client.models.scalar_or_vector import ScalarOrVector
from typing import Optional, Set
from typing_extensions import Self

class MatchTrialEvaluation(BaseModel):
    """
    Evaluation results
    """ # noqa: E501
    status: RunnerStatus
    error: Optional[StrictStr] = Field(default=None, description="Evaluation error information")
    objective: Optional[ScalarOrVector] = None
    constraint: Optional[ScalarOrVector] = None
    info: Optional[Dict[str, Any]] = Field(default=None, description="Auxiliary information for evaluation")
    feasible: Optional[StrictBool] = Field(default=None, description="Whether it is a feasible solution")
    started_at: datetime = Field(description="Evaluation start date and time", alias="startedAt")
    finished_at: datetime = Field(description="Evaluation end date and time", alias="finishedAt")
    __properties: ClassVar[List[str]] = ["status", "error", "objective", "constraint", "info", "feasible", "startedAt", "finishedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MatchTrialEvaluation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of objective
        if self.objective:
            _dict['objective'] = self.objective.to_dict()
        # override the default output from pydantic by calling `to_dict()` of constraint
        if self.constraint:
            _dict['constraint'] = self.constraint.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MatchTrialEvaluation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "status": obj.get("status"),
            "error": obj.get("error"),
            "objective": ScalarOrVector.from_dict(obj["objective"]) if obj.get("objective") is not None else None,
            "constraint": ScalarOrVector.from_dict(obj["constraint"]) if obj.get("constraint") is not None else None,
            "info": obj.get("info"),
            "feasible": obj.get("feasible"),
            "startedAt": obj.get("startedAt"),
            "finishedAt": obj.get("finishedAt")
        })
        return _obj


